/*
 * GIMP Dynamic Text -- This is a plug-in for The GIMP 1.0
 * Copyright (C) 1998,1999,2000 Marco Lamberto <lm@geocities.com>
 * Web page: http://www.geocities.com/Tokyo/1474/gimp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: gdyntextutil.c,v 1.3 2001/02/05 13:00:45 lm Exp $
 */

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gdyntextutil.h"


#ifndef gimp_strcompress

/* substitution of '\' escaped sequences */
gchar *
gimp_strcompress (const gchar *text)
{
	gchar *str = NULL;
	gchar *bstr = NULL;
	gchar *ustr = NULL;
	gchar val[4];

	str = bstr = g_strdup(text);
	while ((str = strchr(str, '\\'))) {
		memcpy(str, str + 1, strlen(str + 1) + 1);
		/* escape sequences recognition */
		switch (*str) {
		case 'n':
			*str = '\n';
			break;
		case 't':
			*str = '\t';
			break;
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			memcpy(val, str, 3);
			val[3] = '\0';
			*str = (gchar)strtol(val, (char **)NULL, 8);
			memcpy(str + 1, str + 3, strlen(str + 2) + 1);
			break;
		}
		str++;
	}
	ustr = g_strdup(bstr);
	g_free(bstr);
	return ustr;
}

#endif
